//+------------------------------------------------------------------+
//|                                             Opening_Range_HF.mq4 |
//|                                      Copyright  2008, Kris Pivo |
//|                                           kris.pivo[at]gmail.com |
//| Opening Range with Fibonacci Extensions            12 April 2008 |
//+------------------------------------------------------------------+
#property copyright " Kris"
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 LimeGreen   // Opening Range Buy Signal
#property indicator_color2 DimGray     // Opening Range High
#property indicator_color3 DimGray     // Opening Range Low
#property indicator_color4 Red         // Opening Range Sell Signal
#property indicator_color5 DarkGreen   // Opening Range Hi +2.618
#property indicator_color6 DarkGreen   // Opening Range Hi +1.618
#property indicator_color7 Maroon      // Opening Range Lo -1.618
#property indicator_color8 Maroon      // Opening Range Lo -2.618

extern int EntryThreshold = 1; 

//---- buffers
double OpenHS[];     // Opening Range Buy Signal
double OpenHi[];     // Opening Range High
double OpenLo[];     // Opening Range Low
double OpenLS[];     // Opening Range Sell Signal
double H2618[];      // Opening Range Hi +2.618
double H1618[];      // Opening Range Hi +1.618
double L1618[];      // Opening Range Lo -1.618
double L2618[];      // Opening Range Lo -2.618

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
	//---- indicators
	SetIndexBuffer(0,OpenHS);
	SetIndexBuffer(1,OpenHi);
	SetIndexBuffer(2,OpenLo);
	SetIndexBuffer(3,OpenLS);
	SetIndexBuffer(4,H2618);
	SetIndexBuffer(5,H1618);
	SetIndexBuffer(6,L1618);
	SetIndexBuffer(7,L2618);
	
	SetIndexStyle(0,DRAW_LINE,STYLE_DOT);
	SetIndexStyle(1,DRAW_LINE,STYLE_SOLID);
	SetIndexStyle(2,DRAW_LINE,STYLE_SOLID);
	SetIndexStyle(3,DRAW_LINE,STYLE_DOT);
	SetIndexStyle(4,DRAW_LINE,STYLE_DOT);
	SetIndexStyle(5,DRAW_LINE,STYLE_DOT);
	SetIndexStyle(6,DRAW_LINE,STYLE_DOT);
	SetIndexStyle(7,DRAW_LINE,STYLE_DOT);

	string short_name = "Opening Range";
	IndicatorShortName(short_name);
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
	ObjectDelete("OR HS");
	ObjectDelete("OR Hi");
	ObjectDelete("OR Lo");
	ObjectDelete("OR LS");
	ObjectDelete("Fib +2.618");
	ObjectDelete("Fib +1.618");
	ObjectDelete("Fib -1.618");
	ObjectDelete("Fib -2.618");
	Comment("");
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

double prevL=0, prevH=0, prevC=0, prevO=0;
double ORHS, ORHi, ORLo, ORLS;
double H262, H162, L162, L262;

int thisHour = -1;

int start() {
	if (Period() > 60) return(0);		//Chart cannot be higher than H1
	
	int counted_bars=IndicatorCounted();
	if (counted_bars >0) counted_bars--;
	int limit=Bars-counted_bars;

	int period = MathCeil(60 / Period());

	for (int i = limit-1; i>=0; i--)
      {
      if (i + period < Bars && TimeMinute(iTime(NULL,0,i)) == 0 && thisHour != TimeHour(iTime(NULL,0,i)) ) {
			thisHour = TimeHour(iTime(NULL,0,i));
			prevH = High[Highest(NULL, 0, MODE_HIGH, period, i+1)];
			prevL = Low [Lowest (NULL, 0, MODE_LOW,  period, i+1)];
			prevC = Close[i+1];

         ORHi = High[i];
         ORLo = Low[i];
         ORHS = ORHi + EntryThreshold*Point;
         ORLS = ORLo - EntryThreshold*Point;
         
         H262 = ORHi + (ORHi-ORLo)*2.62;
         H162 = ORHi + (ORHi-ORLo)*1.62;
         L162 = ORLo - (ORHi-ORLo)*1.62;
         L262 = ORLo - (ORHi-ORLo)*2.62;
      }
		if (ORLo > 0)
		   {
         OpenHS[i] = ORHS;
			OpenHi[i] = ORHi;
			OpenLo[i] = ORLo;
			OpenLS[i] = ORLS;
			H2618[i] = H262;
			H1618[i] = H162;
			L1618[i] = L162;
			L2618[i] = L262;
		   }
	}
	return(0);}
//-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+